Package net.sf.saxon.value

## Class Base64BinaryValue

- java.lang.Object
- - net.sf.saxon.value.AtomicValue
  - - net.sf.saxon.value.Base64BinaryValue

- All Implemented Interfaces:
    `java.lang.Comparable`, `java.lang.Iterable<AtomicValue>`, `AtomicMatchKey`, `AtomicSequence`, `GroundedValue`, `IdentityComparable`, `Item`, `Sequence`, `ConversionResult`

      public class Base64BinaryValue
      extends AtomicValue
      implements AtomicMatchKey, java.lang.Comparable

  A value of type xs:base64Binary

  Rewritten for Saxon 9.5 to avoid dependency on the open-source Netscape code, whose license many users were unhappy with.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.value.AtomicValue

      `typeLabel`

    - ### Fields inherited from interface net.sf.saxon.expr.sort.AtomicMatchKey

      `NaN_MATCH_KEY`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Base64BinaryValue​(byte[] value)` | Constructor: create a base64Binary value from a given array of bytes
    `Base64BinaryValue​(java.lang.CharSequence s)` | Constructor: create a base64Binary value from a supplied string in base64 encoding

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected static int` | `byteArrayHashCode​(byte[] value)` |
    `int` | `compareTo​(java.lang.Object o)` |
    `AtomicValue` | `copyAsSubType​(AtomicType typeLabel)` | Create a copy of this atomic value (usually so that the type label can be changed).
    `static byte[]` | `decode​(java.lang.CharSequence in)` | Decode a character string in base64 notation to yield the encoded octets
    `static java.lang.CharSequence` | `encode​(byte[] value)` | Encode a byte sequence into base64 representation
    `boolean` | `equals​(java.lang.Object other)` | Test if the two base64Binary values are equal.
    `byte[]` | `getBinaryValue()` | Get the binary value
    `int` | `getLengthInOctets()` | Get the number of octets in the value
    `java.lang.String` | `getPrimitiveStringValue()` | Convert to string
    `BuiltInAtomicType` | `getPrimitiveType()` | Determine the primitive type of the value.
    `java.lang.Comparable` | `getSchemaComparable()` | Support XML Schema comparison semantics
    `AtomicMatchKey` | `getXPathComparable​(boolean ordered, StringCollator collator, int implicitTimezone)` | Get an object value that implements the XPath equality and ordering comparison semantics for this value.
    `int` | `hashCode()` |

    - ### Methods inherited from class net.sf.saxon.value.AtomicValue

      `asAtomic, asMapKey, atomize, checkPermittedContents, checkValidInJavascript, effectiveBooleanValue, getCanonicalLexicalRepresentation, getCardinality, getComponent, getGenre, getItemType, getLength, getStringValue, getStringValueCS, getUType, head, identityHashCode, isIdentical, isIdentical, isNaN, itemAt, iterate, iterator, setTypeLabel, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.expr.sort.AtomicMatchKey

      `asAtomic`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `isStreamed, reduce, subsequence, toShortString`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

- - ### Constructor Detail

    - #### Base64BinaryValue

          public Base64BinaryValue​(java.lang.CharSequence s)
                            throws XPathException

      Constructor: create a base64Binary value from a supplied string in base64 encoding
      Parameters:
        `s` - the lexical representation of the base64 binary value. There is no requirement that whitespace should already be collapsed.
      Throws:
        `XPathException` - if the supplied value is not in the lexical space of the xs:base64Binary data type

    - #### Base64BinaryValue

          public Base64BinaryValue​(byte[] value)

      Constructor: create a base64Binary value from a given array of bytes
      Parameters:
        `value` - array of bytes holding the octet sequence

  - ### Method Detail

    - #### copyAsSubType

          public AtomicValue copyAsSubType​(AtomicType typeLabel)

      Create a copy of this atomic value (usually so that the type label can be changed). The type label of the copy will be reset to the primitive type.
      Specified by:
        `copyAsSubType` in class `AtomicValue`
      Parameters:
        `typeLabel` - the type label to be attached to the value, a subtype of xs:base64Binary
      Returns:
        the copied value

    - #### getBinaryValue

          public byte[] getBinaryValue()

      Get the binary value
      Returns:
        the octet sequence that is the typed value

    - #### getPrimitiveType

          public BuiltInAtomicType getPrimitiveType()

      Description copied from class: `AtomicValue`
      Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is xs:anyAtomicType.
      Specified by:
        `getPrimitiveType` in class `AtomicValue`
      Returns:
        the primitive type

    - #### getPrimitiveStringValue

          public java.lang.String getPrimitiveStringValue()

      Convert to string
      Specified by:
        `getPrimitiveStringValue` in class `AtomicValue`
      Returns:
        the canonical representation.

    - #### getLengthInOctets

          public int getLengthInOctets()

      Get the number of octets in the value
      Returns:
        the number of octets

    - #### getSchemaComparable

          public java.lang.Comparable getSchemaComparable()

      Support XML Schema comparison semantics
      Specified by:
        `getSchemaComparable` in interface `AtomicSequence`
      Specified by:
        `getSchemaComparable` in class `AtomicValue`
      Returns:
        a Comparable that follows XML Schema comparison rules

    - #### getXPathComparable

          public AtomicMatchKey getXPathComparable​(boolean ordered,
                                                   StringCollator collator,
                                                   int implicitTimezone)

      Get an object value that implements the XPath equality and ordering comparison semantics for this value. If the ordered parameter is set to true, the result will be a Comparable and will support a compareTo() method with the semantics of the XPath lt/gt operator, provided that the other operand is also obtained using the getXPathComparable() method. In all cases the result will support equals() and hashCode() methods that support the semantics of the XPath eq operator, again provided that the other operand is also obtained using the getXPathComparable() method. A context argument is supplied for use in cases where the comparison semantics are context-sensitive, for example where they depend on the implicit timezone or the default collation.
      Specified by:
        `getXPathComparable` in class `AtomicValue`
      Parameters:
        `ordered` - true if an ordered comparison is required. In this case the result is null if the type is unordered; in other cases the returned value will be a Comparable.
        `collator` - the collation (not used in this version of the method)
        `implicitTimezone` - the XPath dynamic evaluation context, used in cases where the comparison is context
      Returns:
        an Object whose equals() and hashCode() methods implement the XPath comparison semantics with respect to this atomic value. If ordered is specified, the result will either be null if no ordering is defined, or will be a Comparable

    - #### equals

          public boolean equals​(java.lang.Object other)

      Test if the two base64Binary values are equal.
      Specified by:
        `equals` in class `AtomicValue`
      Parameters:
        `other` - the other value
      Returns:
        true if the other operand is an atomic value and the two values are equal as defined by the XPath eq operator

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### byteArrayHashCode

          protected static int byteArrayHashCode​(byte[] value)

    - #### encode

          public static java.lang.CharSequence encode​(byte[] value)

      Encode a byte sequence into base64 representation
      Parameters:
        `value` - the byte sequence
      Returns:
        the base64 representation

    - #### decode

          public static byte[] decode​(java.lang.CharSequence in)
                               throws XPathException

      Decode a character string in base64 notation to yield the encoded octets
      Parameters:
        `in` - the lexical representation
      Returns:
        the array of octets represented
      Throws:
        `XPathException` - if the format is invalid (as required by XSD, this method does draconian error handling, unlike many other base64 decoders which are liberal in what they accept)

    - #### compareTo

          public int compareTo​(java.lang.Object o)

      Specified by:
        `compareTo` in interface `java.lang.Comparable`